<?php

namespace app\modules\controllers;

use app\common\components\Notification;
use app\models\Booth;
use app\models\BoothDevices;
use app\models\Designation;
use app\models\DeviceAppVersion;
use app\models\Devices;
use app\models\Ic;
use app\models\LoginLogout;
use app\models\LoginLogoutSession;
use app\models\Shift;
use DateTime;
use webvimark\modules\UserManagement\models\forms\LoginForm;
use webvimark\modules\UserManagement\models\User;
use Yii;
use yii\web\Controller;
use yii\web\Response;

class AuthController extends Controller
{

    //POST *user authentication
    public function actionUser()
    {

        try {
            $body = @file_get_contents('php://input');
            $obj = json_decode($body);
            Yii::$app->response->format = Response::FORMAT_JSON;
            // device serial from post
            $serial = $obj->serial;
            $app_version = $obj->app_version;
            $session_uuid = $obj->uuid;
            $session_uuid_real = $obj->uuid;
            if (empty($session_uuid)) {
                $response_details = ["success" => false, "status" => "ERROR_SESSION_UUID"];
                return ($response_details);

            }

            //get the device from device_master_list(uncomment this code to serial validate)
            $req_from_device = Devices::find()->where(['serial' => $serial, 'status' => Devices::STATUS_ACTIVE])->one();
            
            $device_app_version = DeviceAppVersion::find()->where(['device_id' => $req_from_device, 'status' => 1])->one();
            
            
            //Checking the app version
            if ($app_version && $device_app_version->app_version != $app_version ) {
            

                $new_device_app_version = new DeviceAppVersion();
                $new_device_app_version->device_id = $req_from_device->id;
                
                $new_device_app_version->app_version = $app_version;
                
                DeviceAppVersion::updateAll(['status' => 0], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', 1]]);
                
                $new_device_app_version->save();
                
            }
            
            $device_is_valid = BoothDevices::find()->where(['status' => BoothDevices::STATUS_ACTIVE, 'device_id' => $req_from_device->id])->one();
            //print_r("ss");die;
            //print_r($device_is_valid);die;

            $model = new LoginForm();
            $model->username = $obj->username;
            $model->password = $obj->password;

            $booth_id = $device_is_valid->booth_id;
            $offlinelogins_array = $obj->offlineLogins;

            //start offline logins save;attached array when login
            if ($offlinelogins_array[0]) {
                foreach ($offlinelogins_array as $obj) {

                    $ic_code = $obj->interchangeId;
                    $ic_id = Ic::find()->where(['code' => $ic_code])->one();

                    $username = $obj->userName;
                    $user = User::find()->where(['username' => $username])->one();
                    $user_id = $user->id;
                    $booth_id = $obj->boothId;
                    $type = $obj->status;
                    $dateTime = $obj->dateTime;
                    $serial = $obj->deviceId;
                    $session_uuid = $obj->session_uuid;
                    $req_from_device = Devices::find()->where(['serial' => $serial])->one();
                    $noti_booth = Booth::find()->where(['id' => $booth_id])->one();

                    //LOGIN
                    if ($type == 1) {

                        $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();
                        $login_logout = new LoginLogout();
                        $login_logout->device_id = $req_from_device->id;
                        $login_logout->user_id = $user_id;
                        $login_logout->booth_id = $booth_id;
                        $login_logout->req_time = $dateTime;
                        $login_logout->shift_id = $shift->id;
                        $login_logout->type = "LOGIN";
                        $login_logout->save();

                        //  LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                        $login_logout_session = new LoginLogoutSession();
                        $login_logout_session->device_id = $req_from_device->id;
                        $login_logout_session->user_id = $user_id;
                        $login_logout_session->booth_id = $booth_id;
                        $login_logout_session->login_type = "OFFLINE";
                        $login_logout_session->login_time = $dateTime;
                        $login_logout_session->shift_id = $shift->id;
                        $login_logout_session->status = LoginLogoutSession::STATUS_ACTIVE;
                        $login_logout_session->session_uuid = $session_uuid;

                        $login_logout_session->save();

                    }

                    //LOGOUT
                    if ($type == 0) {

                        $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();

                        $login_logout = new LoginLogout();
                        $login_logout->device_id = $req_from_device->id;
                        $login_logout->user_id = $user_id;
                        $login_logout->booth_id = $booth_id;
                        $login_logout->req_time = $dateTime;
                        $login_logout->shift_id = $shift->id;
                        $login_logout->type = "LOGOUT";
                        $login_logout->save();

                        $login_logout_session = LoginLogoutSession::find()->where(['device_id' => $req_from_device->id, 'user_id' => $user_id, 'status' => LoginLogoutSession::STATUS_ACTIVE])->one();

                        LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime, 'gate_count' => $obj->gate_count, 'ticket_count' => $obj->ticket_count],
                            ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                        if ($noti_booth->booth_type == 2) {
                            $notify1 = Yii::$app->SaveNotifications->send_to_ht(Notification::KEY_OFFLINE_SYNC, $login_logout_session->id, $ic_id->id);
                            $notify2 = Yii::$app->SaveNotifications->send_to_superadmin(Notification::KEY_OFFLINE_SYNC, $login_logout_session->id, $ic_id->id);
                        }
                    }
                }
            }
            // offline logins save

            //user loggged
            // $model->validate();
            // $errors = $model->errors;
            //  print_r($errors);die;
            if ($model->login()) {

                $user = User::find()->where(['username' => $model->username])->one();
                  $covid_19 = Yii::$app->db->createCommand('SELECT * FROM tbl_config WHERE name="COVID19"')->queryOne();

                //check user has special designations
                if (User::hasRole("25") || User::hasRole("10")) {
                    $tbl_version = Yii::$app->db->createCommand('SELECT * FROM tbl_version')->queryAll();
                    $current_master_fare_version = Yii::$app->db->createCommand('SELECT tbl_version FROM tbl_version WHERE tbl_name ="tbl_fare" ')->queryOne();
                    $current_master_special_fare_version = Yii::$app->db->createCommand('SELECT tbl_version FROM tbl_version WHERE tbl_name ="tbl_fare_special" ')->queryOne();

                    $response_details = [
                        "success" => true,
                        "master_fare_version" => $current_master_fare_version["tbl_version"],
                        "master_special_fare_version" => $current_master_special_fare_version["tbl_version"],
                        "user_id" => $user->id,
                        "username" => $user->username,
                        "designation_id" => $user->designation_id,
                        "designation_name" => 'Super Admin',
                        "tbl_version" => $tbl_version,
                        "interchange_details" => $device_is_valid->ic,
                        "booth_details" => $device_is_valid->booth,
                        "schedule_id" => 0,
                        "shift_id" => 0,
                        "session_id" => 0,
                        "booth_type" => "",
                        "device_name" => $req_from_device->name,
                        "shift_name" => "SHIFT",
                          "without_entrance_status"=>$covid_19["value"]

                    ];
                    $login_logout = new LoginLogout();
                    $login_logout->device_id = $req_from_device->id;
                    $login_logout->user_id = $user->id;
                    $login_logout->req_time = date("Y-m-d H:i:s");
                    $login_logout->type = "LOGIN";
                    $login_logout->save();
                    return ($response_details);

                    // if user is normal
                } else {

                    $active_session = LoginLogoutSession::find()->where(['user_id' => $user->id, 'status' => 1])->one();
                    if ($active_session) {
                        $response_details = ["success" => false, "status" => "ALREADY_HAVE_ACTIVE_SESSION"];
                        return ($response_details);

                    }
                    $booth = Booth::find()->where(['id' => $booth_id])->one();

                    $today = date("Y-m-d");
                    $time = date("H:i:s");
                    $req_time = date("Y-m-d H:i:s");
                    //Find the SHIFT
                    $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $req_time], ['>=', 'shift_end', $req_time], ['=', 'ic_id', $booth->ic->id]])->one();
                    //Find the User is allocated ?
                    $shift_user = Yii::$app->db->createCommand('SELECT * FROM tbl_shift_users WHERE shift_id =' . $shift->id . ' AND user_id = ' . $user->id . ' ')->queryOne();
                    //Interchange Details
                    $interchange_details = Yii::$app->db->createCommand('SELECT * FROM tbl_ic WHERE id= ' . $booth->ic_id . ' ')->queryOne();
                    //Region Details
                    $region_details = Yii::$app->db->createCommand('SELECT * FROM tbl_region WHERE id= ' . $interchange_details["region_id"] . ' ')->queryOne();

                    $current_master_fare_version = Yii::$app->db->createCommand('SELECT tbl_version FROM tbl_version WHERE tbl_name ="tbl_fare" ')->queryOne();
                    $current_master_special_fare_version = Yii::$app->db->createCommand('SELECT tbl_version FROM tbl_version WHERE tbl_name ="tbl_fare_special" ')->queryOne();

                    //Start check ticket count of last session ----------------------
                    $last_session = LoginLogoutSession::find()->orderBy(['id' => SORT_DESC])->where(['user_id' => $user->id])->one();

                    $to_time_in = strtotime($req_time);
                    $from_time_in = strtotime($last_session->logout_time);
                    $difference_in_hour = round(abs(($to_time_in - $from_time_in) / 60) / 60, 4);

                    if ($difference_in_hour >= 8) {
                        $last_session_ticket_count = 0;
                    } elseif ($difference_in_hour < 8 && $difference_in_hour > 0) {

                        $last_session_ticket_count = $last_session->ticket_count;
                    } else {
                        $last_session_ticket_count = 0;
                    }
                    //End check ticket count of last session ----------------------

                    if ($shift_user) {

                        $tbl_version = Yii::$app->db->createCommand('SELECT * FROM tbl_version')->queryAll();

                        $response_details = [

                            "success" => true,
                            "master_fare_version" => $current_master_fare_version["tbl_version"],
                            "master_special_fare_version" => $current_master_special_fare_version["tbl_version"],
                            "booth_type" => $booth->boothType->name,
                            "user_id" => $user->id,
                            "username" => $user->username,
                            "designation_id" => $user->designation_id,
                            "designation_name" => $user->designation->name,
                            "interchange_details" => $interchange_details,
                            "region_name" => $region_details["name"],
                            "booth_details" => $booth,
                            "full_amount_ic" => $booth->fullAmountIc->code,
                            "tbl_version" => $tbl_version,
                            "schedule_id" => 1,
                            "shift_id" => $shift->id,
                            "shift_name" => $shift->shift_name,
                            "session_id" => 0,
                            "device_name" => $req_from_device->name,
                            "last_session_ticket_count" => $last_session_ticket_count,
                              "without_entrance_status"=>$covid_19["value"]
                            // "session_id"=>"1",

                        ];

                        $login_logout = new LoginLogout();
                        $login_logout->device_id = $req_from_device->id;
                        $login_logout->user_id = $user->id;
                        $login_logout->booth_id = $booth->id;
                        $login_logout->req_time = date("Y-m-d H:i:s");
                        $login_logout->shift_id = $shift->id;
                        $login_logout->type = "LOGIN";
                        $login_logout->save();

                        LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'FORCE', 'logout_time' => date("Y-m-d H:i:s")], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                        $login_logout_session = new LoginLogoutSession();
                        $login_logout_session->device_id = $req_from_device->id;
                        $login_logout_session->user_id = $user->id;
                        $login_logout_session->booth_id = $booth->id;
                        $login_logout_session->login_time = date("Y-m-d H:i:s");
                        $login_logout_session->login_type = "ONLINE";
                        $login_logout_session->shift_id = $shift->id;
                        $login_logout_session->status = LoginLogoutSession::STATUS_ACTIVE;
                        $login_logout_session->session_uuid = $session_uuid_real;

                        if ($login_logout_session->save()) {
                            return ($response_details);
                        } else {
                            $response_details = ["success" => false, "status" => "ERROR0"];
                            return ($response_details);
                        }
                    } else {
                        $response_details = ["success" => false, "status" => "ERROR1"];
                        return ($response_details);
                    }

                }

                // if not loggin
            } else {
                $response_details = ["success" => false, "status" => "ERROR2"];
                return ($response_details);
            }
        } catch (\yii\db\Exception $exception) {
            $response_details = ["success" => false, "status" => "ERROR3"];
            return ($response_details);
        } catch (\yii\base\Exception $exception) {
            $response_details = ["success" => false, "status" => "ERROR4"];
            return ($response_details);
        } catch (\Exception $exception) {
            $response_details = ["success" => false, "status" => "ERROR5"];
            return ($response_details);
        }
    }

    public function actionLogout()
    {
        $body = @file_get_contents('php://input');
        $obj_all = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;

        $req_from_device = Devices::find()->where(['serial' => $obj_all->device_id])->one();
        $offlinelogins_array = $obj_all->offlineLogins;

        //start offline logins save
        if ($offlinelogins_array[0]) {
            foreach ($offlinelogins_array as $obj) {

                $ic_code = $obj->interchangeId;
                $ic_id = Ic::find()->where(['code' => $ic_code])->one();

                $username = $obj->userName;
                $user = User::find()->where(['username' => $username])->one();
                $user_id = $user->id;
                $booth_id = $obj->boothId;
                $type = $obj->status;
                $dateTime = $obj->dateTime;
                $serial = $obj->deviceId;
                $session_uuid = $obj->session_uuid;
                $req_from_device = Devices::find()->where(['serial' => $serial])->one();
                $noti_booth = Booth::find()->where(['id' => $booth_id])->one();

                //LOGIN
                if ($type == 1) {

                    $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();
                    $login_logout = new LoginLogout();
                    $login_logout->device_id = $req_from_device->id;
                    $login_logout->user_id = $user_id;
                    $login_logout->booth_id = $booth_id;
                    $login_logout->req_time = $dateTime;
                    $login_logout->shift_id = $shift->id;
                    $login_logout->type = "LOGIN";
                    $login_logout->save();

                    //  LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                    $login_logout_session = new LoginLogoutSession();
                    $login_logout_session->device_id = $req_from_device->id;
                    $login_logout_session->user_id = $user_id;
                    $login_logout_session->booth_id = $booth_id;
                    $login_logout_session->login_type = "OFFLINE";
                    $login_logout_session->login_time = $dateTime;
                    $login_logout_session->shift_id = $shift->id;
                    $login_logout_session->status = LoginLogoutSession::STATUS_ACTIVE;
                    $login_logout_session->session_uuid = $session_uuid;

                    $login_logout_session->save();

                }

                //LOGOUT
                if ($type == 0) {

                    $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();

                    $login_logout = new LoginLogout();
                    $login_logout->device_id = $req_from_device->id;
                    $login_logout->user_id = $user_id;
                    $login_logout->booth_id = $booth_id;
                    $login_logout->req_time = $dateTime;
                    $login_logout->shift_id = $shift->id;
                    $login_logout->type = "LOGOUT";
                    $login_logout->save();

                    $login_logout_session = LoginLogoutSession::find()->where(['device_id' => $req_from_device->id, 'status' => LoginLogoutSession::STATUS_ACTIVE])->one();

                    LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime, 'gate_count' => $obj->gate_count, 'ticket_count' => $obj->ticket_count], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                    if ($noti_booth->booth_type == 2) {
                        $notify1 = Yii::$app->SaveNotifications->send_to_ht(Notification::KEY_OFFLINE_SYNC, $login_logout_session->id, $ic_id->id);
                        $notify2 = Yii::$app->SaveNotifications->send_to_superadmin(Notification::KEY_OFFLINE_SYNC, $login_logout_session->id, $ic_id->id);

                    }

                }

            }

        }

        //save online logout
        $login_logout1 = new LoginLogout();
        $dateTime = date("Y-m-d H:i:s");
        if ($obj_all->shift_id) {
            $login_logout1->shift_id = $obj_all->shift_id;

        } else {
            $ic_code = $obj_all->ic_id;
            $ic_id = Ic::find()->where(['code' => $ic_code])->one();
            $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();
            $login_logout1->shift_id = $shift->id;
        }

        $login_logout1->device_id = $req_from_device->id;
        $login_logout1->user_id = $obj_all->user_id;
        $login_logout1->booth_id = $obj_all->booth_id;
        $login_logout1->req_time = $dateTime;
        $login_logout1->type = "LOGOUT";

        if ($login_logout1->save()) {
            $resp = LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'ONLINE', 'logout_time' => date("Y-m-d H:i:s"), 'gate_count' => $obj_all->gate_count, 'ticket_count' => $obj_all->ticket_count], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);
            $response_details = ["success" => true];
            return ($response_details);

        } else {
            $response_details = ["success" => false];
            return ($response_details);
        }
    }
}
