<?php

namespace app\modules\controllers;

use app\models\Ic;
use Yii;
use yii\web\Controller;
use yii\web\Response;

/**
 * Default controller for the `api` module
 */
class DefaultController extends Controller
{
    /**
     * Renders the index view for the module
     * @return string
     */

    //GET *send tbl_fare data to the POS
    public function actionIndex()
    {
    
       // return true;
        
        Yii::$app->response->format = Response::FORMAT_JSON;
        $body = @file_get_contents('php://input');
        $obj = json_decode($body);
        $ic_code = $obj->interchangeId;
        $ic_id = Ic::find()->where(['code' => $ic_code])->one();

        $result = Yii::$app->db->createCommand('SELECT
        tbl_fare.id,
        tbl_fare.day,
        tbl_fare.vehicle_category_id,
        tbl_fare.final_amount,
        tbl_time_slot.start_time,
        tbl_time_slot.end_time,
        CASE
        WHEN (tbl_time_slot.start_time - tbl_time_slot.end_time) > 0 THEN "1"
        WHEN (tbl_time_slot.start_time - tbl_time_slot.end_time) < 0 THEN "0"
        ELSE "The quantity is under 30"
        END AS day_status,
        tbl_route.distance,
        tbl_route.max_time,


        (SELECT name from tbl_ic WHERE id =tbl_route.source) as "source",
        (SELECT code from tbl_ic WHERE id =tbl_route.source) as "source_id",
        (SELECT name from tbl_ic WHERE id =tbl_route.destination) as "destination",
        (SELECT code from tbl_ic WHERE id =tbl_route.destination) as "destination_id"
        FROM tbl_fare
        INNER JOIN tbl_time_slot ON tbl_fare.time_slot_id = tbl_time_slot.id
        INNER JOIN tbl_vehicle_category ON tbl_fare.vehicle_category_id=tbl_vehicle_category.id
        INNER JOIN tbl_route ON tbl_fare.route_id =tbl_route.id
        WHERE tbl_fare.status=1
        AND tbl_route.destination=' . $ic_id->id . '


        ')->queryAll();
        return $result;

    }
    //GET *send tbl_fare_special data to the POS
    public function actionSpecialFare()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT
         tbl_fare_special.id,
         tbl_fare_special_date.date,
         tbl_fare_special_date.day,
         tbl_fare_special_date.vehicle_category_id,
         tbl_fare_special.final_amount,
         tbl_fare_special_date.start_time,
         tbl_fare_special_date.end_time,
         tbl_route.distance,
         tbl_route.max_time,
         (SELECT name from tbl_ic WHERE id =tbl_route.source) as "source",
         (SELECT code from tbl_ic WHERE id =tbl_route.source) as "source_id",
         (SELECT name from tbl_ic WHERE id =tbl_route.destination) as "destination",
         (SELECT code from tbl_ic WHERE id =tbl_route.destination) as "destination_id"
         FROM tbl_fare_special
         INNER JOIN tbl_fare_special_date ON tbl_fare_special_date.id=tbl_fare_special.special_date_id
         INNER JOIN tbl_vehicle_category ON tbl_fare_special_date.vehicle_category_id=tbl_vehicle_category.id
         INNER JOIN tbl_route ON tbl_fare_special.route_id =tbl_route.id
         WHERE tbl_fare_special_date.date >= "' . date('Y-m-d') . '"
         AND tbl_fare_special.status=1


         ')->queryAll();

        return $result;

    }

    // GET *to sync the version table
    public function actionVersion()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT * FROM tbl_version')->queryAll();
        return $result;

    }
    // GET *to sync the vehicle category table
    public function actionVehicleCategory()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT * FROM tbl_vehicle_category')->queryAll();
        return $result;

    }
    // GET *to sync the vehicle category table
    public function actionIc()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT * FROM tbl_ic')->queryAll();
        return $result;

    }

    public function actionSyncFareOnlyChanged()
    {
        $body = @file_get_contents('php://input');
        $obj = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;
        $ic_code = $obj->interchangeId;
        $ic_id = Ic::find()->where(['code' => $ic_code])->one();

        $tbl_fare_version = $obj->tbl_version;
        $current_master_fare_version = Yii::$app->db->createCommand('SELECT tbl_version FROM tbl_version WHERE tbl_name ="tbl_fare" ')->queryOne();

        $result = Yii::$app->db->createCommand('SELECT newly_inserted FROM tbl_fare_changed WHERE master_tbl_fare_version >' . $tbl_fare_version . ' ')->queryAll();
        $all_changed_objects = [];
        foreach ($result as $one) {
            $ids = json_decode($one['newly_inserted']);
            //    $ids = join(",", $ids);
            foreach ($ids as $id) {
                $objt = Yii::$app->db->createCommand('SELECT

                        tbl_fare.id,
                        tbl_fare.day,
                        tbl_fare.vehicle_category_id,
                        tbl_fare.final_amount,
                        tbl_time_slot.start_time,
                        tbl_time_slot.end_time,
                        tbl_route.distance,
                        tbl_route.max_time,
                        (SELECT name from tbl_ic WHERE id =tbl_route.source) as "source",
                        (SELECT code from tbl_ic WHERE id =tbl_route.source) as "source_id",
                        (SELECT name from tbl_ic WHERE id =tbl_route.destination) as "destination",
                        (SELECT code from tbl_ic WHERE id =tbl_route.destination) as "destination_id"
                        FROM tbl_fare
                        INNER JOIN tbl_time_slot ON tbl_fare.time_slot_id = tbl_time_slot.id
                        INNER JOIN tbl_vehicle_category ON tbl_fare.vehicle_category_id=tbl_vehicle_category.id
                        INNER JOIN tbl_route ON tbl_fare.route_id =tbl_route.id
                        WHERE tbl_fare.id =' . $id . ' AND tbl_fare.status=1 AND tbl_route.destination=' . $ic_id->id . ' ')->queryOne();
                if (isset($objt['id'])) {
                    array_push($all_changed_objects, $objt);
                }

            }

        }

        if ($result) {
            $response_details = [
                "success" => true,
                "master_fare_version" => $current_master_fare_version["tbl_version"],
                "data" => $all_changed_objects,

            ];
            return ($response_details);
        } else {
            $response_details = [
                "success" => false,

            ];
            return ($response_details);
        }
    }

    public function actionInactiveIcList()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT B.barcode FROM tbl_barcode B WHERE B.status = 1')->queryAll();
        return $result;

    }
    
    //GET max time between ic
    public function actionBetweenIcMaxTimeList()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $result = Yii::$app->db->createCommand('SELECT tbl_route.max_time,
         (SELECT name from tbl_ic WHERE id =tbl_route.source) as "source",
         (SELECT code from tbl_ic WHERE id =tbl_route.source) as "source_id",
         (SELECT name from tbl_ic WHERE id =tbl_route.destination) as "destination",
         (SELECT code from tbl_ic WHERE id =tbl_route.destination) as "destination_id"
         FROM tbl_route
         ')->queryAll();
        return $result;

    }
}
