<?php

namespace app\modules\controllers;
use Yii;
use yii\web\Controller;
use yii\web\Response;

use yii\helpers\Json;

use app\models\NfcCard;
use webvimark\modules\UserManagement\models\rbacDB\Role;
use app\models\NfcAllocation;
use app\models\EntranceTicket;




class NfcController extends Controller
{
    
    //POST nfc detail against to UID
    public function actionDetails()
    {
        $body = @file_get_contents('php://input');
        $obj = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;
    
        $uid = $obj->uid;
        $nfc_card = NfcCard::find()->where(['uid'=> $uid,'status' => NfcCard::STATUS_ACTIVE])->one();

         if($nfc_card){
           
            $nfc_card_allocation = NfcAllocation::find()->where(['nfc_card_id'=> $nfc_card->id,'status' => 1])->one();
            
            
            $entrance_ticket = EntranceTicket::find()->where(['uid'=>$nfc_card->uid])->orderBy([
                'entrance_time' => SORT_DESC //specify sort order ASC for ascending DESC for descending      
                ])->one();


            if(isset($entrance_ticket->id)){
                $response_details = [
                    "entrance_time"=>$entrance_ticket->entrance_time,
                    "entrance_serial"=>$entrance_ticket->serial_no ,
                    "entrance_ic"=>$entrance_ticket->entranceIc->code ,
                    "entrance_ic_name"=>$entrance_ticket->entranceIc->name ,
                    "vehicle_no"=>$nfc_card_allocation->vehicle_no,
                    "vehicle_category"=>$nfc_card_allocation->vehicle_category

                ];   
                return ($response_details);
    
            }else{
                $response_details = [
                    "entrance_time"=> "NOT_ASSIGN",
                    "entrance_serial"=> "NOT_ASSIGN",
                    "entrance_ic"=>  "0",
                    "entrance_ic_name"=>  "NOT_ASSIGN",
                    "vehicle_no"=>"NOT_ASSIGN",
                    "vehicle_category"=>"NOT_ASSIGN"
               ];
              
                return ($response_details);
            }
         }else{
            $response_details = [
                "entrance_time"=> "BLACK_LIST",
                "entrance_serial"=> "BLACK_LIST",
                "entrance_ic"=>  "00",
                "entrance_ic_name"=>  "BLACK_LIST",
                "vehicle_no"=>"BLACK_LIST",
                "vehicle_category"=>"BLACK_LIST"
           ];
          
            return ($response_details);
         }   
    }
     //GET all nfc detail against to UID
     public function actionAll()
     {
        
         Yii::$app->response->format = Response::FORMAT_JSON;
       

         $nfc = Yii::$app->db->createCommand('
         SELECT 
         tbl_nfc_card.uid,
         tbl_nfc_card.status,
         coalesce(tbl_nfc_allocation.vehicle_no, "NOT_ASSIGN") as vehicle_no,
         coalesce((SELECT id FROM tbl_vehicle_category WHERE id =tbl_nfc_allocation.vehicle_category), "99") as vehicle_type ,
         coalesce(tbl_nfc_allocation.organization, "NOT_ASSIGN") as organization_name,
         coalesce(tbl_nfc_allocation.department, "NOT_ASSIGN")  as department_name         
            FROM tbl_nfc_card
            LEFT JOIN tbl_nfc_allocation ON tbl_nfc_card.id = tbl_nfc_allocation.nfc_card_id
            WHERE 
            tbl_nfc_allocation.status = '.NfcAllocation::STATUS_ACTIVE.'  OR tbl_nfc_allocation.status IS NULL
                            
                  
                    ')->queryAll();
   
         if($nfc){
             $response_details = $nfc;
             return ($response_details);
 
         }else{
             
             $response_details = ["success" => false ];
             return ($response_details);
         }
 
 
 
     }

       //Save NFC card
       public function actionSave()
       {

        $body = @file_get_contents('php://input');
        $obj = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;

       
      
        $nfc_card = new NfcCard();
        $nfc_card->uid =  $obj->uid;
        $nfc_card->serial =  $obj->serial;
        $nfc_card->status = 1;

       $exist_card =  NfcCard::find()->where(['uid'=> $obj->uid])->one();

        if( empty($exist_card) && $nfc_card->save()){

            // if($obj->vehicle_no){
            //     $nfc_card_allocation = new NfcAllocation();
            //     $nfc_card_allocation->vehicle_category =  $obj->vehicle_type;
            //     $nfc_card_allocation->vehicle_no = $obj->vehicle_no;
            //     $nfc_card_allocation->nfc_card_id = $nfc_card->id;
            //     $nfc_card_allocation->status =1;

            //     if( $nfc_card_allocation->save() ){

            //         $response_details = ["success" => true];
            //         return ($response_details);
    
            //     }else{
            //         $response_details = ["success" => false];
            //         return ($response_details);
            //     }

            // }
		         
            $response_details = ["success" => true];
            return ($response_details);

			


            
        
    
        }else{
            $response_details = ["success" => false,"status"=>"ALREADY_EXISTS"];
            return ($response_details);
        }
       }


}