<?php

namespace app\modules\controllers;

use app\models\Devices;
use app\models\Ic;
use app\models\IcAts;
use app\models\IcAtsAll;
use app\models\IcAtsWeekend;
use app\models\IcHeadTellers;
use app\models\IcHeadTellersWeekend;
use app\models\IcTs;
use app\models\IcUsers;
use app\models\LoginLogout;
use app\models\LoginLogoutSession;
use app\models\Shift;
use webvimark\modules\UserManagement\models\User;
use Yii;
use yii\web\Controller;
use yii\web\Response;
use machour\yii2\notifications\NotificationsModule;
use app\common\components\Notification;
use app\models\Booth;



class OfflineAuthController extends Controller
{

    public function actionUserList()
    {
        $body = @file_get_contents('php://input');
        $obj = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;
        $ic_code = $obj->interchangeId;
        $ic_id = Ic::find()->where(['code' => $ic_code])->one();
        $ic_id = $ic_id->id;

        $ic_user_ids = IcUsers::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();

        $ic_head_tellers_ids = IcHeadTellers::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();
        $ic_head_tellers_weekend_ids = IcHeadTellersWeekend::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();

        $ic_ats_ids = IcAts::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();
        $ic_ats_weekend_ids = IcAtsWeekend::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();
        $ic_ats_all_ids = IcAtsAll::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();

        $ic_ts_ids = IcTs::find()->select('user_id as id')->where(['ic_id' => $ic_id, 'status' => 1])->all();

        $users = User::find()->select('id,username,full_name,encrypted_password,designation_id')
            ->andWhere(['status' => 1])
            ->andWhere(['or',
                ['in', 'id', $ic_user_ids],
                ['in', 'id', $ic_head_tellers_ids],
                ['in', 'id', $ic_head_tellers_weekend_ids],
                ['in', 'id', $ic_ats_ids],
                ['in', 'id', $ic_ats_weekend_ids],
                ['in', 'id', $ic_ats_all_ids],
                ['in', 'id', $ic_ts_ids],
            ])->all();

        return ($users);

    }
    public function actionSaveRecords()
    {
        $body = @file_get_contents('php://input');
        $obj_array = json_decode($body);
        Yii::$app->response->format = Response::FORMAT_JSON;

        foreach ($obj_array as $obj) {

            $ic_code = $obj->interchangeId;
            $ic_id = Ic::find()->where(['code' => $ic_code])->one();
            $session_uuid = $obj->session_uuid;
            $username = $obj->userName;
            $user = User::find()->where(['username' => $username])->one();
            $user_id = $user->id;
            $booth_id = $obj->boothId;
            $type = $obj->status;
            $dateTime = $obj->dateTime;
            $serial = $obj->deviceId;
            $req_from_device = Devices::find()->where(['serial' => $serial])->one();
            $noti_booth =  Booth::find()->where(['id'=>$booth_id])->one();
                   

            //LOGIN
            if ($type == 1) {

                $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();
               
                $login_logout = new LoginLogout();
                $login_logout->device_id = $req_from_device->id;
                $login_logout->user_id = $user_id;
                $login_logout->booth_id = $booth_id;
                $login_logout->req_time = $dateTime;
                $login_logout->shift_id = $shift->id;
                $login_logout->type = "LOGIN";
                $login_logout->save();

                LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);

                $login_logout_session = new LoginLogoutSession();
                $login_logout_session->device_id = $req_from_device->id;
                $login_logout_session->user_id = $user_id;
                $login_logout_session->booth_id = $booth_id;
                $login_logout_session->login_type = "OFFLINE";
                $login_logout_session->login_time = $dateTime;
                $login_logout_session->shift_id = $shift->id;
                $login_logout_session->status = LoginLogoutSession::STATUS_ACTIVE;
                $login_logout_session->session_uuid = $session_uuid; 
                $login_logout_session->save();

            }

            //LOGOUT
            if ($type == 0) {
                $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $dateTime], ['>=', 'shift_end', $dateTime], ['=', 'ic_id', $ic_id->id]])->one();

                $login_logout = new LoginLogout();
                $login_logout->device_id = $req_from_device->id;
                $login_logout->user_id = $user_id;
                $login_logout->booth_id = $booth_id;
                $login_logout->req_time = $dateTime;
                $login_logout->shift_id = $shift->id;
                $login_logout->type = "LOGOUT";
                $login_logout->save();

               $login_logout_session = LoginLogoutSession::find()->where(['device_id' => $req_from_device->id,'user_id'=>$user_id,'status'=>LoginLogoutSession::STATUS_ACTIVE])->one();                          
                     
                LoginLogoutSession::updateAll(['status' => LoginLogoutSession::STATUS_EXPIRED, 'logout_type' => 'OFFLINE', 'logout_time' => $dateTime,'gate_count'=>$obj->gate_count,'ticket_count'=>$obj->ticket_count], ['AND', ['=', 'device_id', $req_from_device->id], ['=', 'status', LoginLogoutSession::STATUS_ACTIVE]]);
                if($noti_booth->booth_type == 2 ){
                        $notify1 = Yii::$app->SaveNotifications->send_to_ht(Notification::KEY_OFFLINE_SYNC, $login_logout_session->id,$ic_id->id);    
                        $notify2 = Yii::$app->SaveNotifications->send_to_superadmin(Notification::KEY_OFFLINE_SYNC,$login_logout_session->id,$ic_id->id);    
         
                }
             
            }

        }
        $response_details = ["success" => true];
        return ($response_details);

    }
}
