<?php

namespace app\modules\controllers;

use app\models\Devices;
use app\models\EntranceTicket;
use app\models\EntranceTicketSync;
use app\models\ExitTicket;
use app\models\ExitTicketSync;
use app\models\Ic;
use app\models\Shift;
use Yii;
use yii\web\Controller;
use yii\web\Response;
use DateTime;
use app\models\ExitTicketSyncInvalid;

class TicketController extends Controller
{

    public function actionSaveEntranceTicket()
    {
        $body = @file_get_contents('php://input');
        Yii::$app->response->format = Response::FORMAT_JSON;
        $entrance_ticket_sync_arrays = EntranceTicketSync::find()->where(['status' => 0])->all();

        try {

            foreach ($entrance_ticket_sync_arrays as $data) {
                foreach ($data->array as $obj) {
                    $entrance_ticket = new EntranceTicket();
                    $ic_id = Ic::find()->where(['code' => $obj["entrance_ic"]])->one();
                    $entrance_ticket->entrance_time = $obj["entrance_time"];
                    $entrance_ticket->serial_no = $obj["entrance_serial"];
                    $entrance_ticket->entrance_ic = (string) $ic_id->id;
                    $entrance_ticket->teller_id = $obj["teller_id"];
                    $entrance_ticket->vehicle_category = $obj["vehicle_category"];
                    $entrance_ticket->booth_id = $obj["booth_id"];
                    $entrance_ticket->created_on = date("Y-m-d H:i:s");
                    $entrance_ticket->ticket_type_status_id = $obj["ticket_type_status_id"];
                    $entrance_ticket->session_id = $obj["session_id"];
                    $entrance_ticket->session_uuid = $obj["session_uuid"];
                    $entrance_ticket->ticket_uuid = $obj["uuid"];

                    if ($obj["shift_id"]) {
                        $entrance_ticket->shift_id = $obj["shift_id"];

                    } else {
                        $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $obj["entrance_time"]], ['>=', 'shift_end', $obj["entrance_time"]], ['=', 'ic_id', (string) $ic_id->id]])->one();
                        $entrance_ticket->shift_id = (string) $shift->id;
                    }

                    $device_detail = Devices::find()->where(['serial' => $obj["device_id"]])->one();
                    $entrance_ticket->device_id = (string) $device_detail->id;
                    $entrance_ticket->decrypted_serial = $obj["decrypted_serial"];

                    if ($obj["u_id"]) {
                        $entrance_ticket->uid = $obj["u_id"];
                    }

                      //  $check_avail = EntranceTicket::find()->where(['ticket_uuid' => $obj["uuid"]])->one();
                        //if (empty($check_avail)) {
                        if (true) {
                            $entrance_ticket->save();
                        }

                }
                EntranceTicketSync::updateAll(['status' => 1], ['=', 'id', $data->id]);

            }
            $response_details = [
                "success" => true,
                "status" => "",
            ];
            return ($response_details);

        } catch (\yii\db\Exception $exception) {
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        } catch (\yii\base\Exception $exception) {
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        } catch (\Exception $exception) {
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        }

    }

    public function actionSaveExitTicket()
    {
        $body = @file_get_contents('php://input');
        Yii::$app->response->format = Response::FORMAT_JSON;
        $exit_ticket_sync_arrays = ExitTicketSync::find()->where(['status' => 0])->all();

        function validateDate($date, $format = 'Y-m-d H:i:s')
                    {
                        $d = DateTime::createFromFormat($format, $date);
                        return $d && $d->format($format) == $date;
                    }

        try {

            foreach ($exit_ticket_sync_arrays as $data) {

                foreach ($data->array as $obj) {

                    $exit_ticket = new ExitTicket();
                    $en_ic_id = Ic::find()->where(['code' => $obj["entrance_ic"]])->one();
                    $ex_ic_id = Ic::find()->where(['code' => $obj["exit_ic"]])->one();
                    $exit_ticket->entrance_serial = $obj["entrance_serial"];
                    $exit_ticket->exit_serial = $obj["exit_serial"];
                    $exit_ticket->entrance_barcode = $obj["barcode"];
                    $exit_ticket->entrance_time = $obj["entrance_time"];                         
                    $exit_ticket->exit_time = $obj["exit_time"];
                    $exit_ticket->vehicle_category = $obj["vehicle_category"];
                    $exit_ticket->booth_id = $obj["booth_id"];
                    $exit_ticket->entrance_ic = (string) $en_ic_id->id;
                    $exit_ticket->exit_ic = (string) $ex_ic_id->id;
                    $exit_ticket->travel_time = $obj["travel_time"];
                    $exit_ticket->avg_speed = $obj["avg_speed"];
                    $exit_ticket->teller_id = $obj["teller_id"];
                    $exit_ticket->amount = $obj["amount"];
                    $exit_ticket->created_on = date("Y-m-d H:i:s");
                    $exit_ticket->ticket_type_status_id = $obj["ticket_type_status_id"];
                    $exit_ticket->session_id = $obj["session_id"];
                    $exit_ticket->session_uuid = $obj["session_uuid"];
                    $exit_ticket->ticket_uuid = $obj["uuid"];
                    $exit_ticket->special_case = $obj["special_case"];
                  

                    if ($obj["shift_id"]) {
                        $exit_ticket->shift_id = $obj["shift_id"];
                    } else {
                        $shift = Shift::find()->where(['AND', ['<=', 'shift_start', $obj["exit_time"]], ['>=', 'shift_end', $obj["exit_time"]], ['=', 'ic_id', (string) $ex_ic_id->id]])->one();
                        $exit_ticket->shift_id = (string) $shift->id;
                    }



                    $device_detail = Devices::find()->where(['serial' => $obj["device_id"]])->one();
                    $exit_ticket->device_id = (string) $device_detail->id;
                    if ($obj["u_id"]) {
                        $exit_ticket->uid = $obj["u_id"];
                    }
                  $check_avail_duplicate_scanned = ExitTicket::find()->where([
                            'session_uuid' => $obj["session_uuid"],
                            'entrance_barcode'=>$obj["barcode"],
                            'entrance_time'=>$obj["entrance_time"],
                            'ticket_type_status_id'=>1
                        ])->one();

                    
                
                     if (empty($check_avail_duplicate_scanned)) {
                     
                  
                            //Start try catch for save();
                            try {
                                if(!empty($exit_ticket->entrance_time) && !validateDate($exit_ticket->entrance_time)) {                                   

                                        $exit_ticket_sync = new ExitTicketSyncInvalid();
                                        $exit_ticket_sync->created_on = date("Y-m-d H:i:s");
                                        $exit_ticket_sync->array = $exit_ticket;
                                        $exit_ticket_sync->status = 0;                                    
                                        $exit_ticket_sync->save();

                                        $exit_ticket->entrance_time = date("Y-m-d H:i:s");
                                }

                                $exit_ticket->save();

                            } catch (\yii\db\Exception $exception) {
                                ExitTicketSync::updateAll(['status' => 2], ['=', 'id', $data->id]);
                                $response_details = [
                                   
                                    "status" => json_encode($exception->getName()),
                                    "success" => false,
                                ];
                                return ($response_details);
                            } catch (\yii\base\Exception $exception) {
                                ExitTicketSync::updateAll(['status' => 2], ['=', 'id', $data->id]);
                                $response_details = [
                                   
                                    "status" => json_encode($exception->getName()),
                                    "success" => false,
                                ];
                                return ($response_details);
                            } catch (\Exception $exception) {
                                ExitTicketSync::updateAll(['status' => 2], ['=', 'id', $data->id]);
                                $response_details = [
                                 
                                    "status" => json_encode($exception->getName()),
                                    "success" => false,
                                ];
                                return ($response_details);
                            }
                            //End try catch for save();


                        }
                }
                ExitTicketSync::updateAll(['status' => 1], ['=', 'id', $data->id]);
            }

            $response_details = [
                "success" => true,
                "status" => "",
            ];
            return ($response_details);

        } catch (\yii\db\Exception $exception) {
            
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        } catch (\yii\base\Exception $exception) {
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        } catch (\Exception $exception) {
            $response_details = [
                "status" => json_encode($exception->getName()),
                "success" => false,
            ];
            return ($response_details);
        }

    }
}
